VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsMediaEngine"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 11/2020
'
' alle mit einem Underscore gekennzeichneten Const, Types,
' Variablen und APIs werden nur intern verwendet!!!

Option Explicit

' ----==== Private Const ====----
Private Const S_OK_ As Long = &H0&
Private Const API_TRUE_ As Long = &H1&
Private Const API_FALSE_ As Long = &H0&
Private Const CC_STDCALL_ As Long = &H4&
Private Const IID_Release_ As Long = &H8&
Private Const D3DFMT_R8G8B8_ As Long = &H14&
Private Const CLSCTX_INPROC_SERVER_ As Long = &H1&

Private Const MF_VERSION_ As Long = &H1&
Private Const MF_STARTUP_FULL_ As Long = &H0&

Private Const IID_IMFMediaEngineEx_ As String = "{83015ead-b1e6-40d0-a98a-37145ffe1ad1}"
Private Const IID_IMFMediaEngineClassFactory_ As String = "{4d645ace-26aa-4688-9be1-df3516990b93}"

Private Const CLSID_MFMediaEngineClassFactory_ As String = "{b44392da-499b-446b-a4cb-005fead0e6d5}"

Private Const MF_MEDIA_ENGINE_CALLBACK_ As String = "{c60381b8-83a4-41f8-a3d0-de05076849a9}"
Private Const MF_MEDIA_ENGINE_PLAYBACK_HWND_ As String = "{d988879b-67c9-4d92-baa7-6eadd446039d}"
Private Const MF_MEDIA_ENGINE_AUDIO_CATEGORY_ As String = "{c8d4c51d-350e-41f2-ba46-faebbb0857f6}"
Private Const MF_MEDIA_ENGINE_AUDIO_ENDPOINT_ROLE_ As String = "{d2cb93d1-116a-44f2-9385-f7d0fda2fb46}"
Private Const MF_MEDIA_ENGINE_VIDEO_OUTPUT_FORMAT_ As String = "{5066893c-8cf9-42bc-8b8a-472212e52726}"

' ----==== Private Enums ====----
Private Enum vtb_Interfaces_
    
    ' --== IUnknown ==--
    QueryInterface_ = 0
    
    ' --== IMFAttributes ==--
    SetUINT32_ = 21
    SetUINT64_ = 22
    SetUnknown_ = 27
    
    ' --== IMFMediaEngineClassFactory ==--
    CreateInstance_ = 3
    
    ' --== IMFMediaEngine ==--
    GetError_ = 3
    SetErrorCode_ = 4
'    SetSourceElements_ = 5
    SetSource_ = 6
    GetCurrentSource_ = 7
    GetNetworkState_ = 8
    GetPreload_ = 9
    SetPreload_ = 10
    GetBuffered_ = 11
    Load_ = 12
    CanPlayType_ = 13
    GetReadyState_ = 14
    IsSeeking_ = 15
    GetCurrentTime_ = 16
    SetCurrentTime_ = 17
    GetStartTime_ = 18
    GetDuration_ = 19
    IsPaused_ = 20
    GetDefaultPlaybackRate_ = 21
    SetDefaultPlaybackRate_ = 22
    GetPlaybackRate_ = 23
    SetPlaybackRate_ = 24
    GetPlayed_ = 25
    GetSeekable_ = 26
    IsEnded_ = 27
    GetAutoPlay_ = 28
    SetAutoPlay_ = 29
    GetLoop_ = 30
    SetLoop_ = 31
    Play_ = 32
    Pause_ = 33
    GetMuted_ = 34
    SetMuted_ = 35
    GetVolume_ = 36
    SetVolume_ = 37
    HasVideo_ = 38
    HasAudio_ = 39
    GetNativeVideoSize_ = 40
    GetVideoAspectRatio_ = 41
    Shutdown_ = 42
'    TransferVideoFrame_ = 43
'    OnVideoStreamTick_ = 44
    
    ' --== IMFMediaEngineEx ==--
    SetSourceFromByteStream_ = 45
    GetStatistics_ = 46
    UpdateVideoStream_ = 47
    GetBalance_ = 48
    SetBalance_ = 49
    IsPlaybackRateSupported_ = 50
    FrameStep_ = 51
    GetResourceCharacteristics_ = 52
    GetPresentationAttribute_ = 53
    GetNumberOfStreams_ = 54
    GetStreamAttribute_ = 55
    GetStreamSelection_ = 56
    SetStreamSelection_ = 57
    ApplyStreamSelections_ = 58
    IsProtected_ = 59
    InsertVideoEffect_ = 60
    InsertAudioEffect_ = 61
    RemoveAllEffects_ = 62
    SetTimelineMarkerTimer_ = 63
    GetTimelineMarkerTimer_ = 64
    CancelTimelineMarkerTimer_ = 65
    IsStereo3D_ = 66
    GetStereo3DFramePackingMode_ = 67
    SetStereo3DFramePackingMode_ = 68
    GetStereo3DRenderMode_ = 69
    SetStereo3DRenderMode_ = 70
    EnableWindowlessSwapchainMode_ = 71
    GetVideoSwapchainHandle_ = 72
    EnableHorizontalMirrorMode_ = 73
    GetAudioStreamCategory_ = 74
    SetAudioStreamCategory_ = 75
    GetAudioEndpointRole_ = 76
    SetAudioEndpointRole_ = 77
    GetRealTimeMode_ = 78
    SetRealTimeMode_ = 79
    SetCurrentTimeEx_ = 80
    EnableTimeUpdateTimer_ = 81

    ' --== IMFMediaTimeRange ==--
    GetLength_ = 3
    GetStart_ = 4
    GetEnd_ = 5
'    ContainsTime_ = 6
'    AddRange_ = 7
'    Clear_ = 8
    
    ' --== IMFMediaError ==--
    GetErrorCode_ = 3
    GetExtendedErrorCode_ = 4
'    SetErrorCode_ = 5
'    SetExtendedErrorCode_ = 6
    
End Enum

Private Enum MF_MEDIA_ENGINE_CREATEFLAGS
    MF_MEDIA_ENGINE_STANDARD = &H0&
    MF_MEDIA_ENGINE_AUDIOONLY = &H1&
    MF_MEDIA_ENGINE_WAITFORSTABLE_STATE = &H2&
    MF_MEDIA_ENGINE_FORCEMUTE = &H4&
    MF_MEDIA_ENGINE_REAL_TIME_MODE = &H8&
    MF_MEDIA_ENGINE_DISABLE_LOCAL_PLUGINS = &H10&
    MF_MEDIA_ENGINE_CREATEFLAGS_MASK = &H1F&
End Enum

' ----==== Private Type ====----
Private Type ABGR_
    Red As Byte
    Green As Byte
    Blue As Byte
    Alpha As Byte
End Type

Private Type ColorLong_
    Color As Long
End Type

' ----==== Kernel32.dll Deklarationen ====----
Private Declare Function SetEvent_ Lib "kernel32.dll" _
                         Alias "SetEvent" ( _
                         ByVal hEvent As Long) As Long
                         
' ----==== Oleaut32.dll Deklarationen ====----
Private Declare Function DispCallFunc_ Lib "Oleaut32.dll" _
                         Alias "DispCallFunc" ( _
                         ByVal pvInstance As Long, _
                         ByVal oVft As Long, _
                         ByVal cc As Long, _
                         ByVal vtReturn As VbVarType, _
                         ByVal cActuals As Long, _
                         ByVal prgvt As Any, _
                         ByVal prgpvarg As Any, _
                         ByRef pvargResult As Variant) As Long
                         
Private Declare Function OleTranslateColor_ Lib "Oleaut32.dll" _
                         Alias "OleTranslateColor" ( _
                         ByVal lOleColor As Long, _
                         ByVal lHPalette As Long, _
                         ByRef lColorRef As Long) As Long
                         
Private Declare Sub SysFreeString_ Lib "Oleaut32.dll" _
                    Alias "SysFreeString" ( _
                    ByRef bstr As String)
                    
' ----==== Ole32 API-Deklarationen ====----
Private Declare Function PropVariantClear_ Lib "ole32.dll" _
                         Alias "PropVariantClear" ( _
                         ByRef pVar As PROPVARIANT) As Long
                         
Private Declare Function CLSIDFromString_ Lib "ole32.dll" _
                         Alias "CLSIDFromString" ( _
                         ByVal pString As Long, _
                         ByRef pCLSID As GUID) As Long
                         
Private Declare Function CoCreateInstance_ Lib "ole32.dll" _
                         Alias "CoCreateInstance" ( _
                         ByVal rclsid As Long, _
                         ByVal pUnkOuter As Long, _
                         ByVal dwClsContext As Long, _
                         ByVal riid As Long, _
                         ByRef ppv As Long) As Long
                         
' ----==== Mfplat.dll Deklarationen ====----
Private Declare Function MFStartup_ Lib "Mfplat.dll" _
                         Alias "MFStartup" ( _
                         ByVal Version As Long, _
                         ByVal dwFlags As Long) As Long
                         
Private Declare Function MFShutdown_ Lib "Mfplat.dll" _
                         Alias "MFShutdown" () As Long
                         
Private Declare Function MFCreateAttributes_ Lib "Mfplat.dll" _
                         Alias "MFCreateAttributes" ( _
                         ByRef ppMFAttributes As Long, _
                         ByVal cInitialSize As Long) As Long
                         

' ----==== Private Variablen ====----
Private m_lngBorderColor_ As Long
Private m_pIMFMediaEngine_ As Long

Private m_bolMFInit_ As Boolean
Private m_bolEffects_ As Boolean
Private m_bolIsNotify_ As Boolean
Private m_bolReadyState_ As Boolean
Private m_bolMFEngineInit_ As Boolean
Private m_bolEnableTimeUpdateTimer_ As Boolean
Private m_bolEnableHorizontalMirrorMode_ As Boolean
Private m_bolEnableWindowlessSwapchainMode As Boolean

' ----==== Events ====----
Public Event ReadyForPlay()
Public Event EventNotify(ByVal eEvent As MF_MEDIA_ENGINE_EVENT, ByVal lParam1 As Long, ByVal lParam2 As Long)

' ----==== Initialize Class ====----
Private Sub Class_Initialize()

    m_bolMFInit_ = False
    m_bolEffects_ = False
    m_bolIsNotify_ = False
    m_bolReadyState_ = False
    m_bolMFEngineInit_ = False
    
    If m_bolMFInit_ = False Then
    
        ' Media Foundation starten
        If MFStartup_(MF_VERSION_, MF_STARTUP_FULL_) = S_OK_ Then
        
            Set modIMFMediaEngineNotify.m_EventNotify = New Collection
                        
            m_bolMFInit_ = True
            
        End If
        
    End If
    
End Sub

Private Sub Class_Terminate()

    If m_bolMFEngineInit_ = True Then
    
        If m_bolEffects_ = True Then
            
            Call RemoveAllEffects
            
        End If
        
        ' IMFMediaEngine herunterfahren
        Call Invoke_(m_pIMFMediaEngine_, Shutdown_, vbLong)
        
        ' Timer stoppen
        m_bolIsNotify_ = False
        
        modNotifyTimer.RunTimer_ = False
        
        ' Interfaces freigeben
        Call Release_(m_pIMFMediaEngine_)
        
        m_bolMFEngineInit_ = False
        
    End If
    
    If m_bolMFInit_ = True Then
    
        Set modIMFMediaEngineNotify.m_EventNotify = Nothing

        ' Media Foundation herunterfahren
        Call MFShutdown_
        
        Call modNotifyTimer.DeleteTimer_
    
        m_bolMFInit_ = False
    
    End If

End Sub

' ----==== Resize ====----
Public Sub Resize(ByVal lLeft As Long, ByVal lTop As Long, ByVal lRight As Long, ByVal lBottom As Long)
    
    Dim tRect As RECT
    
    With tRect
        .Left = lLeft
        .Top = lTop
        .Right = lRight
        .Bottom = lBottom
    End With
    
    If UpdateVideoStream(0&, VarPtr(tRect), 0&) = True Then
        
        DoEvents
        
    End If
    
End Sub

Public Function CreateMediaEngine(ByVal hRenderWnd As Long, _
    Optional ByVal bUseEeventNotifyStableState As Boolean = False, _
    Optional ByVal eEngineMode As EngineMode = RenderingMode, _
    Optional ByVal eAudioStreamCategory As AUDIO_STREAM_CATEGORY = AudioCategory_Media, _
    Optional ByVal eAudioDeviceRole As Role = eMultimedia) As Boolean
    
    Dim bolRet As Boolean
    
    bolRet = False
    
    If m_bolMFEngineInit_ = False Then
    
        ' Interfaces IMFMediaEngine(Ex)erstellen
        If CreateMediaEngine_(m_pIMFMediaEngine_, bUseEeventNotifyStableState, _
            hRenderWnd, eEngineMode, eAudioStreamCategory, eAudioDeviceRole) = True Then
                
            bolRet = True
            m_bolMFEngineInit_ = True
                    
            ' Notify-Timer starten
            m_bolIsNotify_ = True
            
            Call modNotifyTimer.CreateTimer_(hRenderWnd, Me, True)
            
        End If

    End If
            
    CreateMediaEngine = bolRet
    
End Function

Private Function CreateMediaEngine_(ByRef pMediaEngine As Long, _
    Optional ByVal bUseEeventNotifyStableState As Boolean = False, _
    Optional ByVal hRenderWnd As Long = 0&, _
    Optional ByVal eEngineMode As EngineMode = RenderingMode, _
    Optional ByVal eAudioStreamCategory As AUDIO_STREAM_CATEGORY = AudioCategory_Media, _
    Optional ByVal eAudioDeviceRole As Role = eMultimedia) As Boolean
    
    Dim bolRet As Boolean
    Dim pIMFMediaEngine As Long
    Dim pIMFAttributes As Long
    Dim pIMFMediaEngineClassFactory As Long
    Dim eCreateFlags As MF_MEDIA_ENGINE_CREATEFLAGS
    
    bolRet = False
    
    ' IMFMediaEngineClassFactory Interface erstellen
    If CreateInterface_(CLSID_MFMediaEngineClassFactory_, _
        IID_IMFMediaEngineClassFactory_, _
        pIMFMediaEngineClassFactory) = True Then
        
        ' IMFAttributes Interface erstellen
        If MFCreateAttributes_(pIMFAttributes, 0&) = S_OK_ Then
    
            ' Callback Interface festlegen
            If Invoke_(pIMFAttributes, SetUnknown_, vbLong, _
                VarPtr(Str2Guid(MF_MEDIA_ENGINE_CALLBACK_)), _
                modIMFMediaEngineNotify.pIMFMediaEngineNotify_) = S_OK_ Then
                
                ' AudioStreamCategory festlegen
                If Invoke_(pIMFAttributes, SetUINT32_, vbLong, _
                    VarPtr(Str2Guid(MF_MEDIA_ENGINE_AUDIO_CATEGORY_)), _
                    eAudioStreamCategory) = S_OK_ Then
            
                    ' AudioDeviceRole festlegen
                    If Invoke_(pIMFAttributes, SetUINT32_, vbLong, _
                        VarPtr(Str2Guid(MF_MEDIA_ENGINE_AUDIO_ENDPOINT_ROLE_)), _
                        eAudioDeviceRole) = S_OK_ Then
                        
                        ' nach EngineMode selektieren
                        Select Case eEngineMode
                        
                        ' nur AudioMode
                        Case EngineMode.AudioMode
                            
                            eCreateFlags = MF_MEDIA_ENGINE_AUDIOONLY
                            
                            If bUseEeventNotifyStableState = True Then
                            
                                eCreateFlags = eCreateFlags Or _
                                    MF_MEDIA_ENGINE_WAITFORSTABLE_STATE
                            
                            End If
                            
                            bolRet = True
                            
                        ' nur RenderingMode
                        Case EngineMode.RenderingMode
                        
                            eCreateFlags = MF_MEDIA_ENGINE_STANDARD
                        
                            If bUseEeventNotifyStableState = True Then
                            
                                eCreateFlags = eCreateFlags Or _
                                    MF_MEDIA_ENGINE_WAITFORSTABLE_STATE
                            
                            End If
                        
                            ' nur wenn ein Fensterhandle vorhanden ist
                            If hRenderWnd <> 0& Then
        
                                ' Fensterhandle fr die Videoausgabe festlegen
                                If Invoke_(pIMFAttributes, SetUINT64_, vbLong, _
                                    VarPtr(Str2Guid(MF_MEDIA_ENGINE_PLAYBACK_HWND_)), _
                                    hRenderWnd, 0&) = S_OK_ Then
                    
                                    bolRet = True
                    
                                End If
                            
                            End If
        
                        ' nur FrameServerMode
                        Case EngineMode.FrameServerMode
                            
                            eCreateFlags = MF_MEDIA_ENGINE_STANDARD
                            
                            If bUseEeventNotifyStableState = True Then
                            
                                eCreateFlags = eCreateFlags Or _
                                    MF_MEDIA_ENGINE_WAITFORSTABLE_STATE
                            
                            End If
                            
                            ' Video-Outputformat festlegen
                            If Invoke_(pIMFAttributes, SetUINT32_, vbLong, _
                                VarPtr(Str2Guid(MF_MEDIA_ENGINE_VIDEO_OUTPUT_FORMAT_)), _
                                D3DFMT_R8G8B8_) = S_OK_ Then
                    
                                bolRet = True
                    
                            End If
                        
                        End Select
                        
                        If bolRet = True Then
                            
                            ' IMFMediaEngine Interface erstellen
                            If Invoke_(pIMFMediaEngineClassFactory, CreateInstance_, vbLong, _
                                eCreateFlags, pIMFAttributes, VarPtr(pIMFMediaEngine)) = S_OK_ Then
                                
                                ' IMFMediaEngineEx Interface erstellen
                                If Invoke_(pIMFMediaEngine, QueryInterface_, vbLong, _
                                    VarPtr(Str2Guid(IID_IMFMediaEngineEx_)), _
                                    VarPtr(pMediaEngine)) = S_OK_ Then
                                    
                                    Call Release_(pIMFMediaEngine)
                                    
                                    bolRet = True
                    
                                End If
                
                            End If
                        
                        End If
                        
                    End If
                    
                End If
                
            End If
        
            ' aufrumen
            Call Release_(pIMFAttributes)
            
        End If
        
        ' aufrumen
        Call Release_(pIMFMediaEngineClassFactory)
        
    End If
    
    CreateMediaEngine_ = bolRet
    
End Function

Public Sub NotifyTimer_()
    
    Dim lngEventItem As Long
    Dim lngEventCount As Long
    Dim lngEventNotify() As Long
    
    ' Timer stoppen
    modNotifyTimer.RunTimer_ = False
    
    ' nur wenn aktiv
    If m_bolIsNotify_ = True Then
        
        ' Anzahl der Eintrge in der Collection auslesen
        lngEventCount = modIMFMediaEngineNotify.m_EventNotify.Count
        
        ' nur wenn Events vorhanden sind
        If lngEventCount > 0& Then
        
            ' alle aufgelaufenen Events abarbeiten
            For lngEventItem = 0 To lngEventCount - 1
            
                ' erstes Item aus der Collection auslesen
                lngEventNotify = modIMFMediaEngineNotify.m_EventNotify.Item(1)
                
                ' erstes Item aus der Collection lschen
                Call modIMFMediaEngineNotify.m_EventNotify.Remove(1)
                
                ' IMFMediaEngineNotify -> Funktion EventNotify
                ' lngEventNotify(0) = lEvent
                ' lngEventNotify(1) = Param1
                ' lngEventNotify(2) = Param2
                
                ' Debug.Print lngEventNotify(0), lngEventNotify(1), lngEventNotify(2)
                RaiseEvent EventNotify(lngEventNotify(0), lngEventNotify(1), lngEventNotify(2))
                
                If lngEventNotify(0) = MF_MEDIA_ENGINE_EVENT.MF_MEDIA_ENGINE_EVENT_LOADSTART Then
                
                    m_bolReadyState_ = False
                
                End If
                
            Next
            
        End If
        
        If m_bolReadyState_ = False Then
        
            If CLng(Invoke_(m_pIMFMediaEngine_, GetReadyState_, vbInteger)) = _
                MF_MEDIA_ENGINE_READY.MF_MEDIA_ENGINE_READY_HAVE_ENOUGH_DATA Then
            
                m_bolReadyState_ = True
                
                RaiseEvent ReadyForPlay
                
            End If
            
        End If
        
        modNotifyTimer.RunTimer_ = m_bolIsNotify_
        
    End If

End Sub

Public Sub SetNotifyStableStateEvent(ByVal hEvent As Long)

    If hEvent <> 0& Then

        Call SetEvent_(hEvent)
    
    End If
    
End Sub

Public Function Load() As Boolean

    Dim bolRet As Boolean
    
    bolRet = False

        If Invoke_(m_pIMFMediaEngine_, Load_, vbLong) = S_OK_ Then
        
            bolRet = True
        
        End If

    Load = bolRet

End Function

Public Function UpdateVideoStream(Optional ByVal pMFVideoNormalizedRect As Long, _
    Optional ByVal pRect As Long, Optional ByVal pMFARGB As Long) As Boolean

    Dim bolRet As Boolean
    
    bolRet = False

    If Invoke_(m_pIMFMediaEngine_, UpdateVideoStream_, vbLong, _
        pMFVideoNormalizedRect, pRect, pMFARGB) = S_OK_ Then
        
        bolRet = True
        
    End If
    
    UpdateVideoStream = bolRet
    
End Function

Public Function GetNumberOfStreams() As Long
    
    Dim lngVal As Long
    Dim lngRet As Long
    
    If Invoke_(m_pIMFMediaEngine_, GetNumberOfStreams_, vbLong, _
        VarPtr(lngVal)) = S_OK_ Then
        
        lngRet = lngVal
        
    End If
    
    GetNumberOfStreams = lngRet
    
End Function

Public Function CanPlayType(ByVal sType As String) As MF_MEDIA_ENGINE_CANPLAY
    
    Dim lngRet As Long
    Dim eRet As MF_MEDIA_ENGINE_CANPLAY
    
    If Invoke_(m_pIMFMediaEngine_, CanPlayType_, vbLong, sType, VarPtr(lngRet)) = S_OK_ Then
    
        eRet = lngRet
    
    End If
    
    CanPlayType = eRet

End Function

Public Function Play() As Boolean

    Dim bolRet As Boolean
    
    bolRet = False
    
    If Invoke_(m_pIMFMediaEngine_, Play_, vbLong) = S_OK_ Then
    
        bolRet = True
       
    End If

    Play = bolRet
    
End Function

Public Function PausePlay() As Boolean

    Dim bolRet As Boolean
    
    bolRet = False

    If Invoke_(m_pIMFMediaEngine_, Pause_, vbLong) = S_OK_ Then
        
        bolRet = True
    
    End If

    PausePlay = bolRet
    
End Function

Public Function StopPlay(Optional ByVal dCurrentTime As Double = 0) As Boolean

    Dim bolRet As Boolean
    
    bolRet = False

    If Invoke_(m_pIMFMediaEngine_, Pause_, vbLong) = S_OK_ Then
        
        bolRet = SetCurrentTime(dCurrentTime)
    
    End If

    StopPlay = bolRet
    
End Function

Public Function GetDuration() As Double

    Dim strRet As String
    
    strRet = CStr(Invoke_(m_pIMFMediaEngine_, GetDuration_, vbDouble))

    If strRet = "1,#INF" Or strRet = "1,#QNAN" Then
                            
        strRet = "-1"
                            
    End If

    GetDuration = CDbl(strRet)
    
End Function

Public Function GetStartTime() As Double
    
    Dim strRet As String
    
    strRet = CStr(Invoke_(m_pIMFMediaEngine_, GetStartTime_, vbDouble))

    If strRet = "1,#INF" Or strRet = "1,#QNAN" Then
                            
        strRet = "-1"
                            
    End If

    GetStartTime = CDbl(strRet)
    
End Function

Public Function GetCurrentTime() As Double
    
    Dim strRet As String
    
    strRet = CStr(Invoke_(m_pIMFMediaEngine_, GetCurrentTime_, vbDouble))

    If strRet = "1,#INF" Or strRet = "1,#QNAN" Then
                            
        strRet = "-1"
                            
    End If

    GetCurrentTime = CDbl(strRet)
    
End Function

Public Function SetCurrentTime(ByVal dCurrentTime As Double) As Boolean
    
    Dim bolRet As Boolean
    
    bolRet = False
    
    If Invoke_(m_pIMFMediaEngine_, SetCurrentTime_, vbLong, dCurrentTime) = S_OK_ Then
    
        bolRet = True
        
    End If
    
    SetCurrentTime = bolRet
    
End Function

Public Function SetCurrentTimeEx(ByVal dCurrentTime As Double, Optional ByVal eMode As _
    MF_MEDIA_ENGINE_SEEK_MODE = MF_MEDIA_ENGINE_SEEK_MODE_NORMAL) As Boolean

    Dim bolRet As Boolean
    
    bolRet = False
    
    If Invoke_(m_pIMFMediaEngine_, SetCurrentTimeEx_, vbLong, _
        dCurrentTime, CLng(eMode)) = S_OK_ Then
    
        bolRet = True
        
    End If
        
    SetCurrentTimeEx = bolRet

End Function

Public Function CancelTimelineMarkerTimer() As Boolean

    Dim bolRet As Boolean
    
    bolRet = False
    
    If Invoke_(m_pIMFMediaEngine_, CancelTimelineMarkerTimer_, vbLong) = S_OK_ Then
    
        bolRet = True
        
    End If
        
    CancelTimelineMarkerTimer = bolRet
    
End Function

Public Function GetResourceCharacteristics() As MFMEDIASOURCE_CHARACTERISTICS
    
    Dim lngVal As Long
    Dim eRet As MFMEDIASOURCE_CHARACTERISTICS

    If Invoke_(m_pIMFMediaEngine_, GetResourceCharacteristics_, vbLong, VarPtr(lngVal)) = S_OK_ Then
    
        eRet = lngVal
        
    End If
        
    GetResourceCharacteristics = eRet
    
End Function

Public Function GetVideoSwapchainHandle() As Long

    Dim pVal As Long
    Dim pRet As Long

    If Invoke_(m_pIMFMediaEngine_, GetVideoSwapchainHandle_, _
        vbLong, VarPtr(pVal)) = S_OK_ Then
    
        pRet = pVal
        
    End If
    
    GetVideoSwapchainHandle = pRet
    
End Function

Public Function HasVideo() As Boolean

    HasVideo = CBool(Invoke_(m_pIMFMediaEngine_, HasVideo_, vbBoolean))
    
End Function

Public Function HasAudio() As Boolean

    HasAudio = CBool(Invoke_(m_pIMFMediaEngine_, HasAudio_, vbBoolean))
    
End Function

Public Function IsSeeking() As Boolean

    IsSeeking = CBool(Invoke_(m_pIMFMediaEngine_, IsSeeking_, vbBoolean))
    
End Function

Public Function IsPaused() As Boolean

    IsPaused = CBool(Invoke_(m_pIMFMediaEngine_, IsPaused_, vbBoolean))
    
End Function

Public Function IsEnded() As Boolean

    IsEnded = CBool(Invoke_(m_pIMFMediaEngine_, IsEnded_, vbBoolean))
    
End Function

Friend Function GetStatistics(ByVal eStatistic As MF_MEDIA_ENGINE_STATISTIC, _
    ByRef tPropVar As PROPVARIANT) As Boolean

    Dim bolRet As Boolean

    bolRet = False

    If Invoke_(m_pIMFMediaEngine_, GetStatistics_, vbLong, _
        CLng(eStatistic), VarPtr(tPropVar)) = S_OK_ Then
            
        bolRet = True
            
    End If

    GetStatistics = bolRet
    
End Function

Friend Function GetPresentationAttribute(ByRef tRefGuid As GUID, _
    ByRef tPropVar As PROPVARIANT) As Boolean

    Dim bolRet As Boolean

    bolRet = False

    If Invoke_(m_pIMFMediaEngine_, GetPresentationAttribute_, vbLong, _
        VarPtr(tRefGuid), VarPtr(tPropVar)) = S_OK_ Then
            
        bolRet = True
            
    End If
    
    GetPresentationAttribute = bolRet
    
End Function

Friend Function GetStreamAttribute(ByVal lStreamIndex As Long, _
    ByRef tRefGuid As GUID, ByRef tPropVar As PROPVARIANT) As Boolean

    Dim bolRet As Boolean

    bolRet = False

    If Invoke_(m_pIMFMediaEngine_, GetStreamAttribute_, vbLong, _
        lStreamIndex, VarPtr(tRefGuid), VarPtr(tPropVar)) = S_OK_ Then
        
        bolRet = True
            
    End If

    GetStreamAttribute = bolRet
    
End Function

Friend Function ClearPropVariant(ByRef tPropVar As PROPVARIANT) As Boolean

    Dim bolRet As Boolean

    bolRet = False

    If PropVariantClear_(tPropVar) = S_OK_ Then
        
        bolRet = True
        
    End If
    
    ClearPropVariant = True
    
End Function

Public Function FrameStep(Optional ByVal bForward As Boolean = True) As Boolean

    Dim bolRet As Boolean

    bolRet = False
    
    If Invoke_(m_pIMFMediaEngine_, FrameStep_, vbLong, _
        IIf(bForward, API_TRUE_, API_FALSE_)) = S_OK_ Then
        
        bolRet = True
            
    End If

    FrameStep = bolRet
    
End Function

Public Function InsertVideoEffect(ByVal pVideoEffect As Long, _
    ByVal bOptional As Boolean) As Boolean

    Dim bolRet As Boolean

    bolRet = False
    
    If pVideoEffect <> 0& Then

        If Invoke_(m_pIMFMediaEngine_, InsertVideoEffect_, vbLong, _
            pVideoEffect, IIf(bOptional, API_TRUE_, API_FALSE_)) = S_OK_ Then
        
            bolRet = True
            m_bolEffects_ = True
                
        End If
        
    End If

    InsertVideoEffect = bolRet

End Function

Public Function InsertAudioEffect(ByVal pAudioEffect As Long, _
    ByVal bOptional As Boolean) As Boolean

    Dim bolRet As Boolean

    bolRet = False
    
    If pAudioEffect <> 0& Then

        If Invoke_(m_pIMFMediaEngine_, InsertAudioEffect_, vbLong, _
            pAudioEffect, IIf(bOptional, API_TRUE_, API_FALSE_)) = S_OK_ Then
        
            bolRet = True
            m_bolEffects_ = True
            
        End If
        
    End If

    InsertAudioEffect = bolRet

End Function

Public Function GetStreamSelection(ByVal lStreamIndex As Long) As Boolean

    Dim lngRet As Long
    Dim bolRet As Boolean

    If Invoke_(m_pIMFMediaEngine_, GetStreamSelection_, vbLong, _
        lStreamIndex, VarPtr(lngRet)) = S_OK_ Then
        
        bolRet = CBool(lngRet)
            
    End If
    
    GetStreamSelection = bolRet
    
End Function

Public Function SetStreamSelection(ByVal lStreamIndex As Long, _
    ByVal bEnable As Boolean) As Boolean

    Dim bolRet As Boolean

    bolRet = False
    
    If Invoke_(m_pIMFMediaEngine_, SetStreamSelection_, vbLong, _
        lStreamIndex, IIf(bEnable, API_TRUE_, API_FALSE_)) = S_OK_ Then
        
        bolRet = True
            
    End If

    SetStreamSelection = bolRet
    
End Function

Public Function ApplyStreamSelections() As Boolean

    Dim bolRet As Boolean

    bolRet = False
    
    If Invoke_(m_pIMFMediaEngine_, ApplyStreamSelections_, vbLong) = S_OK_ Then
        
        bolRet = True
            
    End If

    ApplyStreamSelections = bolRet
    
End Function

Public Function RemoveAllEffects() As Boolean

    Dim bolRet As Boolean

    bolRet = False
    
    If Invoke_(m_pIMFMediaEngine_, RemoveAllEffects_, vbLong) = S_OK_ Then
        
        bolRet = True
            
    End If

    RemoveAllEffects = bolRet
    
End Function

Public Function IsPlaybackRateSupported(ByVal dPlaybackRate As Double) As Boolean

    IsPlaybackRateSupported = CBool(Invoke_(m_pIMFMediaEngine_, _
        IsPlaybackRateSupported_, vbBoolean, dPlaybackRate))
        
End Function

Public Function IsStereo3D() As Boolean

    IsStereo3D = CBool(Invoke_(m_pIMFMediaEngine_, IsStereo3D_, vbBoolean))
        
End Function

Public Function IsProtected() As Boolean
    
    Dim lngVal As Long
    Dim bolRet As Boolean
    
    If Invoke_(m_pIMFMediaEngine_, IsProtected_, vbLong, VarPtr(lngVal)) = S_OK_ Then
        
        bolRet = CBool(lngVal)
    
    End If
    
    IsProtected = bolRet
    
End Function

Public Function GetNetworkState() As MF_MEDIA_ENGINE_NETWORK

    GetNetworkState = CLng(Invoke_(m_pIMFMediaEngine_, GetNetworkState_, vbInteger))

End Function

Public Function GetReadyState() As MF_MEDIA_ENGINE_READY

    GetReadyState = CLng(Invoke_(m_pIMFMediaEngine_, GetReadyState_, vbInteger))

End Function

Public Function GetNativeVideoSize(ByRef lNativeVideoSizeX As Long, _
    ByRef lNativeVideoSizeY As Long) As Boolean
     
    Dim bolRet As Boolean
    
    bolRet = False
    
    If Invoke_(m_pIMFMediaEngine_, GetNativeVideoSize_, vbLong, _
        VarPtr(lNativeVideoSizeX), VarPtr(lNativeVideoSizeY)) = S_OK_ Then
    
            bolRet = True
        
    End If
    
    GetNativeVideoSize = bolRet
    
End Function

Public Function GetVideoAspectRatio(ByRef lVideoAspectRatioX As Long, _
    ByRef lVideoAspectRatioY As Long) As Boolean
    
    Dim bolRet As Boolean
    
    bolRet = False
    
    If Invoke_(m_pIMFMediaEngine_, GetVideoAspectRatio_, vbLong, _
        VarPtr(lVideoAspectRatioX), VarPtr(lVideoAspectRatioY)) = S_OK_ Then
    
            bolRet = True
        
    End If
    
    GetVideoAspectRatio = bolRet
    
End Function

Public Function GetPlayed(ByRef dStart() As Double, _
    ByRef dEnd() As Double, ByRef lLength As Long) As Boolean

    Dim bolRet As Boolean
    Dim lngIndex As Long
    Dim pIMFMediaTimeRange As Long
    
    bolRet = False
    
    If Invoke_(m_pIMFMediaEngine_, GetPlayed_, vbLong, _
        VarPtr(pIMFMediaTimeRange)) = S_OK_ Then
        
        lLength = CLng(Invoke_(pIMFMediaTimeRange, GetLength_, vbLong))
        
        If lLength > 0& Then
        
            ReDim dStart(lLength - 1)
            ReDim dEnd(lLength - 1)
        
            For lngIndex = 0 To lLength - 1
        
                If Invoke_(pIMFMediaTimeRange, GetStart_, vbLong, _
                    lngIndex, VarPtr(dStart(lngIndex))) = S_OK_ Then
                    
                    If Invoke_(pIMFMediaTimeRange, GetEnd_, vbLong, _
                        lngIndex, VarPtr(dEnd(lngIndex))) = S_OK_ Then
                
                        bolRet = True
            
                    End If
                    
                End If
            
            Next lngIndex
        
        End If
        
        Call Release_(pIMFMediaTimeRange)
        
    End If
    
    GetPlayed = bolRet
    
End Function

Public Function GetSeekable(ByRef dStart() As Double, _
    ByRef dEnd() As Double, ByRef lLength As Long) As Boolean

    Dim bolRet As Boolean
    Dim lngIndex As Long
    Dim pIMFMediaTimeRange As Long
    
    bolRet = False
    
    If Invoke_(m_pIMFMediaEngine_, GetSeekable_, vbLong, _
        VarPtr(pIMFMediaTimeRange)) = S_OK_ Then
        
        lLength = CLng(Invoke_(pIMFMediaTimeRange, GetLength_, vbLong))
        
        If lLength > 0& Then
        
            ReDim dStart(lLength - 1)
            ReDim dEnd(lLength - 1)
        
            For lngIndex = 0 To lLength - 1
        
                If Invoke_(pIMFMediaTimeRange, GetStart_, vbLong, _
                    lngIndex, VarPtr(dStart(lngIndex))) = S_OK_ Then
                    
                    If Invoke_(pIMFMediaTimeRange, GetEnd_, vbLong, _
                        lngIndex, VarPtr(dEnd(lngIndex))) = S_OK_ Then
                
                        bolRet = True
            
                    End If
                    
                End If
            
            Next lngIndex
        
        End If
        
        Call Release_(pIMFMediaTimeRange)
        
    End If
    
    GetSeekable = bolRet
    
End Function

Public Function GetBuffered(ByRef dStart() As Double, _
    ByRef dEnd() As Double, ByRef lLength As Long) As Boolean

    Dim bolRet As Boolean
    Dim lngIndex As Long
    Dim pIMFMediaTimeRange As Long
    
    bolRet = False
    
    If Invoke_(m_pIMFMediaEngine_, GetBuffered_, vbLong, _
        VarPtr(pIMFMediaTimeRange)) = S_OK_ Then
        
        lLength = CLng(Invoke_(pIMFMediaTimeRange, GetLength_, vbLong))
        
        If lLength > 0& Then
        
            ReDim dStart(lLength - 1)
            ReDim dEnd(lLength - 1)
        
            For lngIndex = 0 To lLength - 1
        
                If Invoke_(pIMFMediaTimeRange, GetStart_, vbLong, _
                    lngIndex, VarPtr(dStart(lngIndex))) = S_OK_ Then
                    
                    If Invoke_(pIMFMediaTimeRange, GetEnd_, vbLong, _
                        lngIndex, VarPtr(dEnd(lngIndex))) = S_OK_ Then
                
                        bolRet = True
            
                    End If
                    
                End If
            
            Next lngIndex
        
        End If
        
        Call Release_(pIMFMediaTimeRange)
        
    End If
    
    GetBuffered = bolRet
    
End Function

Public Function GetError(ByRef eErrorCode As MF_MEDIA_ENGINE_ERR, _
    ByRef lExtendedErrorCode As Long) As Boolean

    Dim bolRet As Boolean
    Dim pIMFMediaError As Long
    
    bolRet = False
    
    If Invoke_(m_pIMFMediaEngine_, GetError_, vbLong, _
        VarPtr(pIMFMediaError)) = S_OK_ Then
    
        If pIMFMediaError <> 0& Then
        
            eErrorCode = CLng(Invoke_(pIMFMediaError, _
                GetErrorCode_, vbInteger))
                    
            lExtendedErrorCode = CLng(Invoke_(pIMFMediaError, _
                GetExtendedErrorCode_, vbLong))
                
            bolRet = True
            
        End If
        
        Call Release_(pIMFMediaError)
        
    End If
    
    GetError = bolRet
    
End Function

Public Function GetAutoPlay() As Boolean

    GetAutoPlay = CBool(Invoke_(m_pIMFMediaEngine_, GetAutoPlay_, vbBoolean))
    
End Function

Public Property Let SetAutoPlay(ByVal bAutoPlay As Boolean)
        
    If Invoke_(m_pIMFMediaEngine_, SetAutoPlay_, vbLong, _
        IIf(bAutoPlay, API_TRUE_, API_FALSE_)) = S_OK_ Then
    
    End If
    
End Property

Public Function GetBorderColor() As OLE_COLOR
    
    GetBorderColor = m_lngBorderColor_

End Function

Public Property Let SetBorderColor(ByVal lBorderColor As OLE_COLOR)

    m_lngBorderColor_ = lBorderColor
    
    Call UpdateVideoStream(0&, 0&, VarPtr(Color2MFARGB(lBorderColor)))

End Property

Public Function GetCurrentSource() As String

    Dim strRet As String
    Dim strUrl As String

    If Invoke_(m_pIMFMediaEngine_, GetCurrentSource_, vbLong, _
        VarPtr(strUrl)) = S_OK_ Then
    
        strRet = strUrl
        
        Call SysFreeString_(strUrl)
    
    End If

    GetCurrentSource = strRet
    
End Function

Public Property Let SetErrorCode(ByVal eError As MF_MEDIA_ENGINE_ERR)

    If Invoke_(m_pIMFMediaEngine_, SetErrorCode_, _
        vbLong, CLng(eError)) = S_OK_ Then
        
    End If
    
End Property

Public Property Let SetSource(ByVal sURL As String)

    If sURL <> vbNullString Then
    
        If Invoke_(m_pIMFMediaEngine_, SetSource_, _
            vbLong, sURL) = S_OK_ Then
        
        End If
    
    End If
    
End Property

Public Function SetSourceFromByteStream(ByVal pIMFByteStream As Long, _
    ByVal sURL As String) As Boolean

    Dim bolRet As Boolean

    bolRet = False
    
    If pIMFByteStream <> 0& Then

        If sURL <> vbNullString Then

            If Invoke_(m_pIMFMediaEngine_, SetSourceFromByteStream_, _
                vbLong, pIMFByteStream, sURL) = S_OK_ Then
        
                bolRet = True
            
            End If
                
        End If
        
    End If

    SetSourceFromByteStream = bolRet

End Function

Public Function GetMuted() As Boolean
    
    GetMuted = CBool(Invoke_(m_pIMFMediaEngine_, GetMuted_, vbBoolean))

End Function

Public Property Let SetMuted(ByVal bMuted As Boolean)
    
    If Invoke_(m_pIMFMediaEngine_, SetMuted_, vbLong, _
        IIf(bMuted, API_TRUE_, API_FALSE_)) = S_OK_ Then
        
    End If
    
End Property

Public Function GetVolume() As Double
    
    GetVolume = CDbl(Invoke_(m_pIMFMediaEngine_, GetVolume_, vbDouble) * 100)

End Function

Public Property Let SetVolume(ByVal dVolume As Double)
    
    If dVolume < 0 Then dVolume = 0
    If dVolume > 100 Then dVolume = 100
    
    If Invoke_(m_pIMFMediaEngine_, SetVolume_, vbLong, _
        CDbl(dVolume / 100)) = S_OK_ Then
    
    End If
    
End Property

Public Function GetBalance() As Double
    
    GetBalance = CDbl(Invoke_(m_pIMFMediaEngine_, GetBalance_, vbDouble) * 100)
        
End Function

Public Property Let SetBalance(ByVal dBalance As Double)
    
    If dBalance < -100 Then dBalance = -100
    If dBalance > 100 Then dBalance = 100
    
    If Invoke_(m_pIMFMediaEngine_, SetBalance_, vbLong, _
        CDbl(dBalance / 100)) = S_OK_ Then
            
    End If
    
End Property

Public Function GetLoop() As Boolean
    
    GetLoop = CBool(Invoke_(m_pIMFMediaEngine_, GetLoop_, vbBoolean))

End Function

Public Property Let SetLoop(ByVal bLoop As Boolean)
    
    If Invoke_(m_pIMFMediaEngine_, SetLoop_, vbLong, _
        IIf(bLoop, API_TRUE_, API_FALSE_)) = S_OK_ Then
        
    End If
    
End Property

Public Function GetPreload() As MF_MEDIA_ENGINE_PRELOAD
    
    GetPreload = CLng(Invoke_(m_pIMFMediaEngine_, GetPreload_, vbLong))
    
End Function

Public Property Let SetPreload(ByVal ePreload As MF_MEDIA_ENGINE_PRELOAD)
    
    If Invoke_(m_pIMFMediaEngine_, SetPreload_, vbLong, _
        CLng(ePreload)) = S_OK_ Then
            
    End If
        
End Property

Public Function GetDefaultPlaybackRate() As Double

    GetDefaultPlaybackRate = CDbl(Invoke_(m_pIMFMediaEngine_, _
        GetDefaultPlaybackRate_, vbDouble))
    
End Function

Public Property Let SetDefaultPlaybackRate(ByVal dPlaybackRate As Double)

    If Invoke_(m_pIMFMediaEngine_, SetDefaultPlaybackRate_, vbLong, _
        dPlaybackRate) = S_OK_ Then
            
    End If
    
End Property

Public Function GetPlaybackRate() As Double

    GetPlaybackRate = CDbl(Invoke_(m_pIMFMediaEngine_, _
        GetPlaybackRate_, vbDouble))
    
End Function

Public Property Let SetPlaybackRate(ByVal dPlaybackRate As Double)

    If Invoke_(m_pIMFMediaEngine_, SetPlaybackRate_, vbLong, _
        dPlaybackRate) = S_OK_ Then
            
    End If
    
End Property

Public Function GetEnableHorizontalMirrorMode() As Boolean
    
    GetEnableHorizontalMirrorMode = m_bolEnableHorizontalMirrorMode_

End Function

Public Property Let SetEnableHorizontalMirrorMode(ByVal bEnable As Boolean)
    
    m_bolEnableHorizontalMirrorMode_ = bEnable
    
    If Invoke_(m_pIMFMediaEngine_, EnableHorizontalMirrorMode_, vbLong, _
        IIf(bEnable, API_TRUE_, API_FALSE_)) = S_OK_ Then
    
    End If
        
End Property

Public Function GetRealTimeMode() As Boolean
        
    Dim lngVal As Long
    Dim bolRet As Boolean
        
    If Invoke_(m_pIMFMediaEngine_, GetRealTimeMode_, vbLong, VarPtr(lngVal)) = S_OK_ Then
        
        bolRet = CBool(lngVal)
    
    End If
    
    GetRealTimeMode = bolRet

End Function

Public Property Let SetRealTimeMode(ByVal bEnable As Boolean)
    
    If Invoke_(m_pIMFMediaEngine_, SetRealTimeMode_, vbLong, _
        IIf(bEnable, API_TRUE_, API_FALSE_)) = S_OK_ Then
    
    End If

End Property

Public Function GetEnableTimeUpdateTimer() As Boolean

    GetEnableTimeUpdateTimer = m_bolEnableTimeUpdateTimer_
    
End Function

Public Property Let SetEnableTimeUpdateTimer(ByVal bEnable As Boolean)

    m_bolEnableTimeUpdateTimer_ = bEnable
    
    If Invoke_(m_pIMFMediaEngine_, EnableTimeUpdateTimer_, vbLong, _
        IIf(bEnable, API_TRUE_, API_FALSE_)) = S_OK_ Then
    
    End If
        
End Property

Public Function GetAudioEndpointRole() As Role
    
    Dim lngVal As Long
    Dim eRet As Role
    
    If Invoke_(m_pIMFMediaEngine_, GetAudioEndpointRole_, vbLong, _
        VarPtr(lngVal)) = S_OK_ Then
            
        eRet = lngVal
    
    End If
    
    GetAudioEndpointRole = eRet
    
End Function

Public Property Let SetAudioEndpointRole(ByVal eRole As Role)
    
    If Invoke_(m_pIMFMediaEngine_, SetAudioEndpointRole_, vbLong, _
        CLng(eRole)) = S_OK_ Then
    
    End If
    
End Property

Public Function GetAudioStreamCategory() As AUDIO_STREAM_CATEGORY

    Dim lngVal As Long
    Dim eRet As AUDIO_STREAM_CATEGORY
    
    If Invoke_(m_pIMFMediaEngine_, GetAudioStreamCategory_, vbLong, _
        VarPtr(lngVal)) = S_OK_ Then
            
        eRet = lngVal
    
    End If

    GetAudioStreamCategory = eRet
    
End Function

Public Property Let SetAudioStreamCategory(ByVal eCategory As AUDIO_STREAM_CATEGORY)
    
    If Invoke_(m_pIMFMediaEngine_, SetAudioStreamCategory_, vbLong, _
        CLng(eCategory)) = S_OK_ Then
    
    End If
    
End Property

Public Function GetStereo3DRenderMode() As MF3DVideoOutputType
    
    Dim lngVal As Long
    Dim eRet As MF3DVideoOutputType
    
    If Invoke_(m_pIMFMediaEngine_, GetStereo3DRenderMode_, vbLong, _
        VarPtr(lngVal)) = S_OK_ Then
            
        eRet = lngVal
    
    End If
    
    GetStereo3DRenderMode = eRet
    
End Function

Public Property Let SetStereo3DRenderMode(ByVal e3DRenderMode As MF3DVideoOutputType)
    
    If Invoke_(m_pIMFMediaEngine_, SetStereo3DRenderMode_, vbLong, _
        CLng(e3DRenderMode)) = S_OK_ Then
    
    End If
    
End Property

Public Function GetStereo3DFramePackingMode() As MF_MEDIA_ENGINE_S3D_PACKING_MODE
    
    Dim lngVal As Long
    Dim eRet As MF_MEDIA_ENGINE_S3D_PACKING_MODE
    
    If Invoke_(m_pIMFMediaEngine_, GetStereo3DFramePackingMode_, vbLong, _
        VarPtr(lngVal)) = S_OK_ Then
            
        eRet = lngVal
    
    End If
    
    GetStereo3DFramePackingMode = eRet
    
End Function

Public Property Let SetStereo3DFramePackingMode(ByVal ePackingMode As MF_MEDIA_ENGINE_S3D_PACKING_MODE)

    If Invoke_(m_pIMFMediaEngine_, SetStereo3DFramePackingMode_, _
        vbLong, CLng(ePackingMode)) = S_OK_ Then
    
    End If
    
End Property

Public Function GetTimelineMarkerTimer() As Double

    Dim dblVal As Double
    Dim dblRet As Double
    
    If Invoke_(m_pIMFMediaEngine_, GetTimelineMarkerTimer_, vbLong, _
        VarPtr(dblVal)) = S_OK_ Then
            
        dblRet = CDbl(dblVal)
    
    End If
        
    GetTimelineMarkerTimer = dblRet
    
End Function

Public Property Let SetTimelineMarkerTimer(ByVal dTimeToFire As Double)

    If dTimeToFire < 0 Then dTimeToFire = 0

    If Invoke_(m_pIMFMediaEngine_, SetTimelineMarkerTimer_, vbLong, _
        dTimeToFire) = S_OK_ Then
    
    End If
        
End Property

Public Function GetEnableWindowlessSwapchainMode() As Boolean
    
    GetEnableWindowlessSwapchainMode = m_bolEnableWindowlessSwapchainMode
    
End Function

Public Property Let SetEnableWindowlessSwapchainMode(ByVal bEnable As Boolean)
    
    m_bolEnableWindowlessSwapchainMode = bEnable
    
    If Invoke_(m_pIMFMediaEngine_, EnableWindowlessSwapchainMode_, vbLong, _
        IIf(bEnable, API_TRUE_, API_FALSE_)) = S_OK_ Then
    
    End If
    
End Property

Friend Function Color2MFARGB(ByVal lColor As Long) As MFARGB

    Dim lngColor As Long
    Dim tABGR_ As ABGR_
    Dim tColorLong_ As ColorLong_

    If OleTranslateColor_(lColor, 0&, lngColor) = S_OK_ Then
    
        If (lngColor And &HFF000000) = 0& Then

            lngColor = lngColor Or &HFF000000

        End If
    
        tColorLong_.Color = lngColor
    
        LSet tABGR_ = tColorLong_
    
        With Color2MFARGB
            .rgbAlpha = tABGR_.Alpha
            .rgbRed = tABGR_.Red
            .rgbGreen = tABGR_.Green
            .rgbBlue = tABGR_.Blue
        End With
    
    End If

End Function



' ----==== Create Interface ====----
Private Function CreateInterface_(ByVal sCLSID As String, _
    ByVal sIID As String, ByRef pInterface As Long) As Boolean

    Dim bRet As Boolean
    Dim tIID As GUID
    Dim tCLSID As GUID

    bRet = False
    
    ' CLSID -> GUID
    If CLSIDFromString_(StrPtr(sCLSID), tCLSID) = S_OK_ Then

        ' IID -> GUID
        If CLSIDFromString_(StrPtr(sIID), tIID) = S_OK_ Then

            ' Interface erstellen
            If CoCreateInstance_(VarPtr(tCLSID), 0&, CLSCTX_INPROC_SERVER_, _
                VarPtr(tIID), pInterface) = S_OK_ Then

                bRet = True

            End If

        End If

    End If

    CreateInterface_ = bRet

End Function

' ----==== Call OleInvoke_ ====----
Private Function Invoke_(ByVal pInterface As Long, ByVal vtb As vtb_Interfaces_, _
    ByVal vReturn As VbVarType, ParamArray var()) As Variant
    
    If pInterface <> 0& Then
    
        Invoke_ = OleInvoke_(pInterface, vtb, vReturn, var)
        
    End If
    
End Function

' ----==== Release Interface ====----
Private Sub Release_(ByRef pInterface As Long)

    Dim vRet As Variant

    ' ist ein Pointer auf ein Interfac vorhanden
    If pInterface <> 0& Then

        ' Funktion Release des Interfaces aufrufen
        If DispCallFunc_(pInterface, IID_Release_, CC_STDCALL_, vbLong, _
            0&, 0&, 0&, vRet) = S_OK_ Then

            pInterface = 0&

        End If

    End If

End Sub

' ----==== Call Interface Function ====----
Private Function OleInvoke_(ByVal pInterface As Long, ByVal lCmd As Long, _
    ByVal vReturn As VbVarType, ParamArray aParam()) As Variant
    
    Dim lCount As Long
    Dim lItem As Long
    Dim vRet As Variant
    Dim vParam As Variant
    Dim olePtr(10) As Long
    Dim oleTyp(10) As Integer

    ' wenn ein Pointer auf ein Interface vorhanden ist
    If pInterface <> 0& Then

        ' nur wenn zum Aufruf der Interface-Funktion auch
        ' Parameter vorhanden sind.
        If UBound(aParam) >= 0 Then

            ' ParamArray nach Variant
            vParam = aParam

            ' ist der Variant ein Array
            If IsArray(vParam) Then vParam = vParam(0)

            ' Anzahl der Parameter
            lCount = UBound(vParam)

            ' alle Parameter durchlaufen
            For lItem = 0 To lCount

                ' Typ des Parameter
                oleTyp(lItem) = VarType(vParam(lItem))

                ' Pointer auf den Parameter
                olePtr(lItem) = VarPtr(vParam(lItem))

            Next

        End If

        ' Funktion des Interfaces aufrufen
        If DispCallFunc_(pInterface, lCmd * 4, CC_STDCALL_, vReturn, _
            lItem, VarPtr(oleTyp(0)), VarPtr(olePtr(0)), vRet) <> S_OK_ Then
            
            Debug.Print "Fehler beim Aufrufen der Interface-Funktion!"

        End If

    End If
    
    OleInvoke_ = vRet

End Function

' ----==== String -> GUID ====----
Private Function Str2Guid(ByVal sGUID As String) As GUID

    Call CLSIDFromString_(StrPtr(sGUID), Str2Guid)
    
End Function
