Attribute VB_Name = "modNotifyTimer"
' Autor: F. Schler (frank@activevb.de)
' Datum: 11/2020
'
' alle mit einem Underscore gekennzeichneten Const, Types,
' Variablen und APIs werden nur intern verwendet!!!

Option Explicit

' ----==== Const ====----
Private Const TIMER_IDEVENT_ As Long = &HFF&
Private Const USER_TIMER_MINIMUM_ As Long = &HA&

' ----==== User32.dll Deklarationen ====----
Private Declare Function SetTimer_ Lib "User32.dll" _
                         Alias "SetTimer" ( _
                         ByVal hWnd As Long, _
                         ByVal nIDEvent As Long, _
                         ByVal uElapse As Long, _
                         ByVal lpTimerFunc As Long) As Long
                         
Private Declare Function KillTimer_ Lib "User32.dll" _
                         Alias "KillTimer" ( _
                         ByVal hWnd As Long, _
                         ByVal nIDEvent As Long) As Long
                         
' ----==== Variablen ====----
Private m_hOwnerWnd_ As Long
Private m_lngTimerID_ As Long
Private m_bolRunTimer_ As Boolean
Private m_cMediaEngine_ As clsMediaEngine

Public Sub CreateTimer_(ByVal hWnd As Long, ByRef cMediaEngine As clsMediaEngine, _
    Optional ByVal bRunTimer As Boolean = False)

    m_hOwnerWnd_ = hWnd
    m_bolRunTimer_ = bRunTimer
    Set m_cMediaEngine_ = cMediaEngine
    
    m_lngTimerID_ = SetTimer_(m_hOwnerWnd_, TIMER_IDEVENT_, _
        USER_TIMER_MINIMUM_, AddressOf TimerCallBack_)
    
End Sub

Public Sub DeleteTimer_()

    Call KillTimer_(m_hOwnerWnd_, m_lngTimerID_)
    
    Set m_cMediaEngine_ = Nothing
    
End Sub

Public Property Let RunTimer_(ByVal bEnable As Boolean)

    m_bolRunTimer_ = bEnable
    
End Property

Private Sub TimerCallBack_(ByVal hWnd As Long, ByVal uMsg As Long, _
    ByVal idEvent As Long, ByVal dwTime As Long)
    
    If m_bolRunTimer_ = True Then
    
        If idEvent = TIMER_IDEVENT_ Then
            
            Call m_cMediaEngine_.NotifyTimer_
        
        End If
    
    End If
    
End Sub
